# This script calculates the CRPS deterioration over the forecast lead time 

#-------------------------------------

#Specify here the GloFAS station ID of interest e.g. G5378

station_id="G5249"

#-------------------------------------

#Load data:
data=readMat(paste(station_id,"_glofasdata.mat",sep=''))
data=unlist(data) 
dataarray=array(data,dim=c(2830,51,31)) 
startdate=as.numeric(as.Date(c("2008-04-01")))

#Extract the water balance data:
wbdata=dataarray[,1,1]

#Reshape the water balance list into a 2D array, columns of 30:
wb=wbdata[2:31]
for(i in 2:2799){wb=rbind(wb,wbdata[(i+1):(i+30)])}


#Create an empty array for the CRPS:
#Loop over lead times to compute the CRPS at each:
CRPSfinal = rep(0,30)
for(i in 1:30){crps=crpsDecomposition(wb[,i],dataarray[1:2799,,i+1])$CRPS
CRPSfinal[i]=crps}

print(CRPSfinal)

#png(paste(station_id,"_CRPS_deterioration.png",sep=''))

#Plot deterioration of CRPS with lead time:
plot(CRPSfinal,ann=FALSE)
title(main="CRPS Deterioration with Forecast Lead Time",xlab="Lead Time (Days)",ylab="CRPS")

#dev.off()
