#-------------------------------------

#Specify here the GloFAS station ID of interest e.g. G5378

station_id="G5249"

#Specify here the lead time you would like to evaluate (in days):

leadtime=1

#-------------------------------------

#Load data:
data=readMat(paste(station_id,"_glofasdata.mat",sep=''))
data=unlist(data) 
dataarray=array(data,dim=c(2830,51,31)) 
startdate=as.numeric(as.Date(c("2008-04-01")))

#Load observed data:
observed=read.csv(paste(station_id,"_observed.csv",sep='')) #,stringsAsFactors=FALSE
print(observed)
#observed[is.na(observed)]=NaN
print(observed[,1])

forecastdates=as.Date(c(1:2830)+13969+leadtime,origin="1970-01-01")

forecastdata=dataarray[,,leadtime]

forecastmean=apply(forecastdata,c(1),mean)
#print(forecastmean)

#Compute Nash-Sutcliffe Efficiency Average over timeseries
nse = NSE(forecastmean,observed[,1],na.rm=TRUE)
print(nse)
nse=round(nse,digits=3)

plot(forecastdates,forecastmean,type='l',xlim=c(13970,2830+13969),ylim=c(0,max(dataarray[,1,leadtime],na.rm=TRUE)),xlab="Date",
     ylab="Flow (m3/s)",col="black")

lines(forecastdates,observed[,1],col="red")

legend("topright",quantile(dataarray[,1,leadtime],0.999,na.rm=TRUE),c("Forecast Mean","Observed"),col=c("Black","Red"),lty=1,lwd=2,bty="n")
title(main=paste("NSE at lead time",leadtime,"days =",nse))